using System;
using UnityEngine;

namespace Utils
{
    public class PhysicsEventManager : MonoBehaviour
    {
        public delegate void FixedUpdateAction();

        public static event FixedUpdateAction FixedUpdated;

        private void FixedUpdate()
        {
            FixedUpdated?.Invoke();
        }

        private void OnApplicationQuit()
        {
            FixedUpdated = null;
        }

        public static Delegate[] FixedUpdateDelegates => FixedUpdated?.GetInvocationList();

        public static int FixedUpdateLength => FixedUpdateDelegates?.Length ?? 0;
    }
}